package main

import (
	"database/sql"
	"fmt"

	"github.com/uptrace/bun"
	"github.com/uptrace/bun/dialect/pgdialect"
	"github.com/uptrace/bun/driver/pgdriver"
)

// Tofu Provider is the goal
// Data Sources first
// Resources later

//var users []UserModel
//var ssh_keys []SSHKeyModel
//var servers []Server
//var server_definitions []ServerDefinition
//var manifests []Manifest
//var jobs []Job
//var hosts []Host

func main() {
	var (
		pgdsn = "postgres://postgres:Initial1@localhost:15432/anvil?sslmode=disable"
	)
	anvil := new(Anvil)
	anvil.AddStriker(Striker{})
	// anvil.Strikers[0].SetFQDN("mh-striker01.libre.audio")
	e := &PostgresClient{bun.NewDB(sql.OpenDB(pgdriver.NewConnector(pgdriver.WithDSN(pgdsn))), pgdialect.New())}

	anvil.Strikers[0].AddEndpoint(e)
	fmt.Printf("Strikers[0].Endpoints.PostgresClient = %s.\n", anvil.Strikers[0].Endpoints.PostgresClient)
	// fmt.Printf("Strikers[0].FQDN = %s.\n", anvil.Strikers[0].FQDN)
}
