package main

import (
	"fmt"
	"reflect"
)

func (p PostgresClient) IsEndpoint() bool {
	return true
}

func (w WebClient) IsEndpoint() bool {
	return true
}

func (s SSHClient) IsEndpoint() bool {
	return true
}

func (s *Striker) SetFQDN(fqdn string) {
	s.FQDN = fqdn
}

func (s *Striker) AddEndpoint(e Endpoint) {
	// type switch statement
	// https://go.dev/tour/methods/16
	fmt.Printf("e value = %s.\n", reflect.TypeOf(e))
	switch t := e.(type) {
	case *PostgresClient:
		s.Endpoints.PostgresClient = e
	case *WebClient:
		s.Endpoints.WebClient = e
	case *SSHClient:
		s.Endpoints.SSHClient = e
	default:
		fmt.Println("Undefined behavior for type %s.\n", t)
	}
}

func (a *Anvil) AddStriker(s Striker) {
	a.Strikers = append(a.Strikers, s)
}
