package main

import (
	"net/http"

	"github.com/uptrace/bun"
	"golang.org/x/crypto/ssh"
)

type Anvil struct {
	Strikers []Striker
	Hosts    []Host
	BMCs     []BMC
	Switches []Switch
	PDUs     []PDU
	UPSes    []UPS
}

type Endpoints struct {
	WebClient      Endpoint
	SSHClient      Endpoint
	PostgresClient Endpoint
}

type WebClient struct {
	*http.Client
}

type SSHClient struct {
	*ssh.Client
}

type PostgresClient struct {
	*bun.DB
}

type Striker struct {
	FQDN      string
	Endpoints Endpoints
}

type Host struct {
	FQDN      string
	Endpoints Endpoints
}

type BMC struct {
}

type Switch struct {
}

type PDU struct {
}

type UPS struct {
}
